******************************************************************
*  BROWSE.PRG:  General purpose browse program.                  *
*  Initial Version by Bryan Cooper and Monique Verrier           *
*  10/27/1987                                                    *
*  Note that a window must be open BEFORE calling Browse         *
******************************************************************

parameters bscreen, recstart 
set procedure to browproc    

******************************************************************
*  Section 1:  Find correct browse record to show on screen      *
******************************************************************
PRIVATE select
store ltrim(str(select(),2,0)) to select
select browse
seek select + bscreen

if eof()   && This should not happen in production jobs.
  w.set size to 1, 1, 2, 70
  w.display
  wait "  No such Browse screen: " + str(select(),1,0) + ' ' + escreen
  select &select
  return
endif

*******************************************************************
*  Section 2:  Set proper browse parameters based on browse record*
*******************************************************************
w.set frame on
w.set size to trow, tcol, brow, bcol  && Make browse window correct size
w.display

PRIVATE maxrec, startrow, rec
PRIVATE title, field1, maxrec2, row, helpkey, quitkey, deleteok
PRIVATE selekey, seleprog, cont, browrec

store brow - trow + 1 to maxrec 
store 0 to startrow             
store recstart to rec
store '' to title, field1, maxrec2, row,helpkey, quitkey
store '' to selekey, seleprog

******************************************************************
*  Section 3:  Call browset to set variables, paint first screen.*
******************************************************************
do browset        

******************************************************************
*  Section 4:  Main browse loop to display records on screen     *
******************************************************************

store .t. to cont
do while cont                 
  * Put macro substituted data into memvar "messages", and
  * highlight on screen.
  store &field1 to messages
  set color to &selected, &normal, &backg     
  @ row,0 say messages + iif(delete(),' DEL','    ')
  store inkey() to entered
  do while entered = 0                      && Wait for key press
     store inkey() to entered
     @ row, 0 say ""
  enddo
  *    Un-highlight current line after key has been hit.
  set color to &normal, &selected, &backg
  @ row,0 say messages + iif(delete(),' DEL','    ')
******************************************************************
*  Section 5:  Browse case statement to determine action based   *
*              on key hit in inkey().                            *
******************************************************************
  do case                     && Now, parse key hit:
  case entered = 5            && Up arrow or Ctrl-E
    skip -1
    if .not. bof()
       store row-1 to row
       if row < 0             && Scroll Down one line
         do scrolld
       endif
    else
       goto top
    endif
  case entered = 24            && Down arrow or Ctrl-X
    skip 1
    if .not. eof()
      store row+1 to row
      if row > maxrec-1        && Scroll-Up screen one line
        do scrollu
      endif
    else
      skip -1
    endif
  case entered = 1             && Home key or Ctrl-A
    skip -row
    store 0 to row
  case entered = 6             && End key or Ctrl-F
    store maxrec2-1-row to row
    skip row
    store maxrec2-1 to row
  case entered = 18            && PgUp or Ctrl-R
    do scrollpu
  case entered = 3             && PgDown or Ctrl-C
    do scrollpd
  case entered = 4 .or. entered = 19        && Right arrow or Ctrl-D
                                            && Left arrow or Ctrl-S
    do nextbrow                && Look for another browse screen
  case entered = m->helpkey    && Puts up help screen
    do browhelp
    select &select
  case entered = m->selekey    && Runs program (usually an edit program)
    select browse
    store recno() to browrec   && Save current browse position
    select &select
    do &seleprog               && Call select program with macro
    select browse              && Restore browse position
    go browrec
    select &select
  *case entered = m->appendkey && Write an append option!?!
  * do &append
  *case entered = m->browmenu  && Write a browse menu!?!
  * do browmenu
  case entered = m->quitkey    && Exit from Browse
    store .f. to cont
  case entered = 21 .and. m->deleteok  && Deletes current record
    delete
  endcase
  * Loop back up for next key stroke, unless quitkey was hit...
enddo cont
******************************************************************
*  That's IT!!                                                   *
******************************************************************
select &select    && Return to original database area
return

*** END BROWSE.PRG
